# Generated by Django 3.2.13 on 2022-10-10 13:42

from django.db import migrations

import sys


def cleanup_role_binding(apps, schema_editor):
    UserRoleBinding = apps.get_model('profiles', 'UserRoleBinding')
    TeamRoleBinding = apps.get_model('profiles', 'TeamRoleBinding')
    remove_binding_on_deleted_objects(apps, UserRoleBinding.objects.all())
    remove_binding_on_deleted_objects(apps, TeamRoleBinding.objects.all())


def remove_binding_on_deleted_objects(apps, binding_qs):
    count = 1
    for binding in binding_qs:
        model = apps.get_model(binding.content_type.app_label, binding.content_type.model)
        if not model.objects.filter(id=binding.object_id).exists():
            binding.delete()
        print('{:s}\r'.format(''), end='', flush=True)
        print(f'{count}/{binding_qs.count()}', end='')
        count += 1


class Migration(migrations.Migration):
    dependencies = [
        ('profiles', '0008_auto_20221010_1542'),
    ]

    operations = [
        migrations.RunPython(cleanup_role_binding),
    ]
